(*

  Achtung dieses Beispiel ist nur zur Demonstration der verschiedenen
  Funktionen ...

  In grsseren Projekten empfiehlt es sich,aus Zeitgrnden,grere
  zusammenhngende Blcke zu lesen/schreiben,da dadurch weniger
  Auftrge laufen ...


  Benutzt werden AB2 und AB3, DB10 DW0 - DW15, einige Merkerbytes/Worte.
  Siehe Step5 - Beispielprogramm...
  
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Simatic, StdCtrls, ExtCtrls, HiResTimer;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    lblMW0: TLabel;
    lblDW0: TLabel;
    Bevel1: TBevel;
    Label5: TLabel;
    Timer1: TTimer;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    lblT10: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    PLC     : TPLC;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  PLC.Com := COM1;
  if AgInit(PLC) then
    Timer1.Enabled := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Timer1.Enabled := False;
  AgExit(PLC);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var  MW0 : Word;
     DW0 : Word;
begin
  if AgReadMW(PLC, 0, @MW0) then
    lblMW0.Caption := WordToBin(MW0)
  else
    MessageBeep($FFFF);
  if AgReadDataBlock(PLC, 10, 0, 1, @DW0) then
    lblDW0.Caption := IntToHex(DW0, 4)
  else
    MessageBeep($FFFF);
  if AgReadTimer(PLC, 10, MW0, DW0) then
    if MW0 > 0 then
      lblT10.Caption := IntToStr(MW0) + '.' + IntToStr(DW0)
    else
      lblT10.Caption := 'Steht'
  else
    MessageBeep($FFFF);
end;

procedure TForm1.Button1Click(Sender: TObject);
var  MB6 : Byte;
begin
  MB6 := Random($FF);
  if not AgWriteMB(PLC, 6, @MB6) then
    MessageBeep($FFFF);
end;

procedure TForm1.Button2Click(Sender: TObject);
var  AB3 : Byte;
begin
  AB3 := Random($FF);
  if not AgWriteAB(PLC, 3, @AB3) then
    MessageBeep($FFFF);
end;

end.
